Magellan Linux

Diff of /trunk/grubby/new-kernel-pkg

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

trunk/mkinitrd-magellan/grubby/new-kernel-pkg revision 532 by niro, Sat Sep 1 22:45:15 2007 UTC trunk/grubby/new-kernel-pkg revision 2684 by niro, Wed Jul 16 10:26:39 2014 UTC
# Line 1  Line 1 
1  #!/bin/bash  #!/bin/bash
2    # $Id$
3  #  #
4    # new-kernel-pkg
5  # Invoked upon installation or removal of a kernel package, the following  # Invoked upon installation or removal of a kernel package, the following
6  # tasks are/can be done here:  # tasks are/can be done here:
7  # creation/removal of initrd  # creation/removal of initrd
8  # run of depmod/removal of depmod generated files  # run of depmod/removal of depmod generated files
9  # addition/removal of kernel images from grub/lilo configuration (via grubby)  # addition/removal of kernel images from grub/lilo configuration (via grubby)
10  #  #
11  # Copyright (C) 2002-2005 Red Hat, Inc.  # Copyright 2002-2008 Red Hat, Inc.  All rights reserved.
 #  
12  # modified for Magellan-Linux by Niels Rogalla <niro@magellan-linux.de>  # modified for Magellan-Linux by Niels Rogalla <niro@magellan-linux.de>
13  #  #
14    # This program is free software; you can redistribute it and/or modify
15    # it under the terms of the GNU General Public License as published by
16    # the Free Software Foundation; either version 2 of the License, or
17    # (at your option) any later version.
18    #
19    # This program is distributed in the hope that it will be useful,
20    # but WITHOUT ANY WARRANTY; without even the implied warranty of
21    # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
22    # GNU General Public License for more details.
23    #
24    # You should have received a copy of the GNU General Public License
25    # along with this program.  If not, see <http://www.gnu.org/licenses/>.
26    #
27    
28    read_os_release()
29    {
30     local NAME
31     local ID
32     local Version
33     local Version_ID
34     local PRETTY_NAME
35     local ANSI_COLOR
36     local CPE_NAME
37    
38     if [[ -f /etc/os-release ]]
39     then
40     source /etc/os-release
41    
42     case $1 in
43     name) echo "${NAME}" ;;
44     id) echo "${ID}" ;;
45     version) echo "${Version}" ;;
46     version_id) echo "${Version_ID}" ;;
47     pretty_name) echo "${PRETTY_NAME}" ;;
48     ansi_color) echo "${ANSI_COLOR}" ;;
49     cpe_name) echo "${CPE_NAME}" ;;
50     esac
51     fi
52    }
53    
54  PATH=/sbin:/bin:$PATH  PATH=/sbin:/bin:$PATH
55    
# Line 18  lilo=/sbin/lilo Line 58  lilo=/sbin/lilo
58  # some defaults that are sane for most arches  # some defaults that are sane for most arches
59  kernelName=kernel  kernelName=kernel
60    
61  if [ -x ./grubby ]; then  if [ -x ./grubby ]
62      grubby=./grubby  then
63     grubby=./grubby
64  else  else
65      grubby=/sbin/grubby   grubby=/sbin/grubby
66  fi  fi
67    
68  [ -f /etc/sysconfig/kernel ] && . /etc/sysconfig/kernel  [ -f /etc/conf.d/grubby ] && . /etc/conf.d/grubby
69    [ -f /etc/conf.d/grubby-uboot ] && . /etc/conf.d/grubby-uboot
70    
71    cfgGrub2=""
72    cfgGrub2Efi=""
73  cfgGrub=""  cfgGrub=""
74  cfgLilo=""  cfgLilo=""
75    cfgExtlinux=""
76    cfguBoot=""
77  runLilo=""  runLilo=""
78  grubConfig=""  grubConfig=""
79    grub2Config=""
80    grub2EfiConfig=""
81    extlinuxConfig=""
82    
83  ARCH=$(uname -m)  ARCH=$(uname -m)
84    
85  if [ $ARCH = 'ia64' ]; then  if [[ ${ARCH} = ia64 ]]
86      liloConfig=/boot/efi/EFI/redhat/elilo.conf  then
87      bootPrefix=/boot/efi/EFI/redhat   liloConfig=/boot/efi/EFI/redhat/elilo.conf
88      liloFlag=elilo   bootPrefix=/boot/efi/EFI/redhat
89      isx86=""   liloFlag=elilo
90  elif [ $ARCH = 'ppc64' -o $ARCH = 'ppc' ]; then   isx86=""
91      liloConfig=/etc/yaboot.conf  elif [[ ${ARCH} = ppc64 ]] || [[ ${ARCH} = ppc ]]
92      bootPrefix=/boot  then
93      lilo=/sbin/ybin   liloConfig=/etc/yaboot.conf
94      liloFlag=yaboot   grub2Config=/boot/grub/grub.cfg
95      runLilo="yes"   bootPrefix=/boot
96      isx86=""   lilo=/sbin/ybin
97  elif [ $ARCH = 'sparc' -o $ARCH = 'sparc64' ]; then   liloFlag=yaboot
98      liloConfig=/etc/silo.conf   runLilo="yes"
99      bootPrefix=/boot   isx86=""
100      liloFlag=silo  elif [[ ${ARCH} = sparc ]] || [[ ${ARCH} = sparc64 ]]
101      lilo=/sbin/silo  then
102      isx86=""   liloConfig=/etc/silo.conf
103  elif [ $ARCH = 's390' -o $ARCH = 's390x' ]; then   bootPrefix=/boot
104      liloConfig=/etc/zipl.conf   liloFlag=silo
105      bootPrefix=/boot   lilo=/sbin/silo
106      liloFlag=zipl   isx86=""
107      lilo=/sbin/zipl  elif [[ ${ARCH} = s390 ]] || [[ ${ARCH} = s390x ]]
108      runLilo="yes"  then
109      isx86=""   liloConfig=/etc/zipl.conf
110     bootPrefix=/boot
111     liloFlag=zipl
112     lilo=/sbin/zipl
113     runLilo="yes"
114     isx86=""
115    elif [[ ${ARCH} =~ armv[5|7].*l ]]
116    then
117     liloConfig=""
118     bootPrefix=/boot
119     extlinuxConfig=$(readlink -f /etc/extlinux.conf 2>/dev/null)
120     ubootDir=${UBOOT_DIR:-"/boot"}
121     ubootScript=$ubootDir/${UBOOT_SCR:-"boot.scr"}
122     ubootKList=${UBOOT_KLIST:-"klist.txt"}
123     ubootDevice=/dev/${UBOOT_DEVICE:-"mmcblk0p1"}
124     ubootDefaultImage=${UBOOT_UIMAGE:-"uImage"}
125     ubootDefaultInitrd=${UBOOT_UINITRD:-"uInitrd"}
126     ubootAddress=${UBOOT_IMGADDR:-"0x00008000"}
127     mounted=""
128     liloFlag=""
129     isx86=""
130  else  else
131      # this leaves i?86 and x86_64   # this leaves i?86 and x86_64
132      liloConfig=/etc/lilo.conf   liloConfig=/etc/lilo.conf
133      grubConfig=/boot/grub/grub.conf   grubConfig=/boot/grub/grub.conf
134      bootPrefix=/boot   grub2Config=/boot/grub/grub.cfg
135      liloFlag=lilo   grub2EfiConfig=/boot/grub/grub-efi.cfg
136      isx86="yes"   extlinuxConfig=/boot/extlinux/extlinux.conf
137     bootPrefix=/boot
138     liloFlag=lilo
139     isx86="yes"
140  fi  fi
141    
142  mode=""  mode=""
143  version=""  version=""
144  initrd=""  initrd=""
145    dracut=""
146    dracuthostonly=""
147  initrdfile=""  initrdfile=""
148  moddep=""  moddep=""
149  verbose=""  verbose=""
150  makedefault=""  makedefault=""
151  package=""  package=""
152  mbkernel=""  mbkernel="${HYPERVISOR}"
153  mbargs=""  mbargs="${HYPERVISOR_ARGS}"
154    adddracutargs=""
155    addplymouthinitrd=""
156    
157    usage()
158    {
159     echo "Usage: $(basename $0) [-v] [--mkinitrd] [--rminitrd] [--dracut]" >&2
160     echo "       [--initrdfile=<initrd-image>] [--depmod] [--rmmoddep]" >&2
161     echo "       [--kernel-args=<args>] [--remove-args=<args>]" >&2
162     echo "       [--banner=<banner>] [--multiboot=multiboot]" >&2
163     echo "       [--mbargs=mbargs] [--make-default] [--add-dracut-args]" >&2
164     echo "       [--add-plymouth-initrd]" >&2
165     echo "       [--host-only]" >&2
166     echo "       <--install | --remove | --update> <kernel-version>" >&2
167     echo "       (ex: $(basename $0) --mkinitrd --depmod --install 2.4.7-2)" >&2
168     exit 1
169    }
170    
171    install()
172    {
173     # XXX kernel should be able to be specified also (or work right on ia64)
174     if [ ! -f ${kernelImage} ]
175     then
176     [[ -n ${verbose} ]] && echo "kernel for ${version} does not exist, not running grubby"
177     return
178     fi
179    
180     INITRD=""
181     if [ -f ${initrdfile} ]
182     then
183     [[ -n ${verbose} ]] && echo "found ${initrdfile} and using it with grubby"
184     INITRD="--initrd ${initrdfile}"
185    
186     if [[ -n ${addplymouthinitrd} ]]
187     then
188     INITRD="${INITRD} --extra-initrd ${bootPrefix}/initrd-plymouth.img"
189     fi
190     fi
191    
192     # FIXME: is this a good heuristic to find out if we're on iSeries?
193     if [ -d /proc/iSeries ]
194     then
195     [[ -n ${verbose} ]] && echo "On an iSeries, just making img file"
196     if [[ -z ${initrdfile} ]]
197     then
198     [[ -n ${verbose} ]] && echo "No initrd, just adding system map"
199     /sbin/addSystemMap ${bootPrefix}/System.map-${version} ${kernelImage} ${bootPrefix}/vmlinitrd-${version}
200     else
201     /sbin/addSystemMap ${bootPrefix}/System.map-${version} ${kernelImage} ${bootPrefix}/vmlinux.sm-${version}
202     /sbin/addRamDisk ${initrdfile} ${bootPrefix}/System.map-${version} ${bootPrefix}/vmlinux.sm-${version} ${bootPrefix}/vmlinitrd-${version} 2>/dev/null
203     rm ${bootPrefix}/vmlinux.sm-${version}
204     fi
205     return
206     fi
207    
208     # get the root filesystem to use
209     rootdevice=$(awk '{ if ($1 !~ /^[ \t]*#/ && $2 == "/") { print $1; }}' /etc/fstab  2>/dev/null)
210     if [[ -z $rootdevice ]]
211     then
212     rootdevice=$(grep -o -P "(?<=root=)\S+" /proc/cmdline)
213     fi
214    
215     if [[ -n ${mbkernel} ]] && [[ -n ${cfgLilo} ]] && [[ ${liloFlag} != elilo ]]
216     then
217     [[ -n ${verbose} ]] && echo "multiboot specified, not updating lilo.conf"
218     cfgLilo=""
219     fi
220    
221     if [[ -n ${banner} ]]
222     then
223     if [[ ${ARCH} = s390 ]] || [[ ${ARCH} = s390x ]]
224     then
225     title=$(echo ${banner} | sed 's/ /_/g')
226     else
227     title="${banner} [ ${version} ]"
228     fi
229     elif [[ ${ARCH} = s390 ]] || [[ ${ARCH} = s390x ]]
230     then
231     title=$(echo ${version} | sed 's/ /_/g')
232     elif [ -f /etc/os-release ]
233     then
234     title="$(read_os_release name) $(read_os_release version_id) [ ${version} ]"
235     elif [ -f /etc/mageversion ]
236     then
237     title="Magellan Linux $(< /etc/mageversion) [ ${version} ]"
238     else
239     title="Magellan Linux [ ${version} ]"
240     fi
241    
242     if [[ -n ${cfgGrub} ]]
243     then
244     [[ -n ${verbose} ]] && echo "adding ${version} to ${grubConfig}"
245    
246     ${grubby} --grub -c ${grubConfig} \
247     --add-kernel=${kernelImage} \
248     ${INITRD} --copy-default ${makedefault} --title "${title}" \
249     ${mbkernel:+--add-multiboot="${mbkernel}"} ${mbargs:+--mbargs="${mbargs}"} \
250     --args="root=${rootdevice} ${kernargs}" --remove-kernel="TITLE=${title}"
251     else
252     [[ -n ${verbose} ]] && echo "${grubConfig} does not exist, not running grubby for grub 0.97"
253     fi
254     if [[ -n ${cfgGrub2} ]]
255     then
256     [[ -n ${verbose} ]] && echo "adding ${version} to ${grub2Config}"
257    
258     ${grubby} --grub2 -c ${grub2Config} \
259     --add-kernel=${kernelImage} \
260     ${INITRD} --copy-default ${makedefault} --title "${title}" \
261     ${mbkernel:+--add-multiboot="${mbkernel}"} \
262     ${mbargs:+--mbargs="${mbargs}"} \
263     --args="root=${rootdevice} ${kernargs}" --remove-kernel="TITLE=${title}"
264     else
265     [[ -n ${verbose} ]] && echo "${grub2Config} does not exist, not running grubby for grub 2"
266     fi
267     if [[ -n ${cfgGrub2Efi} ]]
268     then
269     [[ -n ${verbose} ]] && echo "adding ${version} to ${grub2EfiConfig}"
270    
271     ${grubby} --grub2 -c ${grub2EfiConfig} --efi \
272     --add-kernel=${kernelImage} \
273     ${INITRD} --copy-default ${makedefault} --title "${title}" \
274     ${mbkernel:+--add-multiboot="${mbkernel}"} \
275     ${mbargs:+--mbargs="${mbargs}"} \
276     --args="root=${rootdevice} ${kernargs}" --remove-kernel="TITLE=${title}"
277     else
278     [[ -n ${verbose} ]] && echo "${grub2EfiConfig} does not exist, not running grubby for grub 2 with UEFI"
279     fi
280    
281     if [[ -n ${cfgLilo} ]]
282     then
283     [[ -n ${verbose} ]] && echo "adding ${version} to ${liloConfig}"
284    
285     ${grubby} --add-kernel=${kernelImage} ${INITRD} \
286     --copy-default ${makedefault} --title "${title}" \
287     ${mbkernel:+--add-multiboot="${mbkernel}"} ${mbargs:+--mbargs="${mbargs}"} \
288     --args="root=${rootdevice} ${kernargs}" --remove-kernel="TITLE=${version}" \
289     --${liloFlag}
290    
291     if [[ -n ${runLilo} ]]
292     then
293     [[ -n ${verbose} ]] && echo "running ${lilo}"
294     if [ ! -x ${lilo} ]
295     then
296     [[ -n ${verbose} ]] && echo "${lilo} does not exist"
297     else
298     ${lilo} > /dev/null
299     fi
300     fi
301     else
302     [[ -n ${verbose} ]] && echo "${liloConfig} does not exist, not running grubby"
303     fi
304    
305  usage() {   if [[ -n ${cfgExtlinux} ]]
306      echo "Usage: `basename $0` [-v] [--mkinitrd] [--rminitrd]" >&2   then
307      echo "       [--initrdfile=<initrd-image>] [--depmod] [--rmmoddep]" >&2   [[ -n ${verbose} ]] && echo "adding ${version} to ${extlinuxConfig}"
308      echo "       [--kernel-args=<args>] [--banner=<banner>]" >&2  
309      echo "       [--multiboot=multiboot] [--mbargs=mbargs]" >&2   ${grubby} --extlinux -c ${extlinuxConfig} \
310      echo "       [--make-default] <--install | --remove> <kernel-version>" >&2   --add-kernel=${kernelImage} \
311      echo "       (ex: `basename $0` --mkinitrd --depmod --install 2.4.7-2)" >&2   ${INITRD} --copy-default ${makedefault} --title "${title}" \
312      exit 1   ${mbkernel:+--add-multiboot="${mbkernel}"} ${mbargs:+--mbargs="${mbargs}"} \
313     --args="root=${rootdevice} ${kernargs}" --remove-kernel="TITLE=${title}"
314     else
315     [[ -n ${verbose} ]] && echo "${extlinuxConfig} does not exist, not running grubby for extlinux"
316     fi
317  }  }
318    
319  install() {  remove()
320      # XXX kernel should be able to be specified also (or work right on ia64)  {
321      if [ ! -f $bootPrefix/$kernelName-$version ] ; then   # FIXME: is this a good heuristic to find out if we're on iSeries?
322   [ -n "$verbose" ] && echo "kernel for $version does not exist, not running grubby"   if [ -d /proc/iSeries ]
323   return   then
324      fi   [[ -n ${verbose} ]] && echo "On an iSeries, remove img file"
325         rm -f ${kernelImage}.img 2>/dev/null
326      INITRD=""   return
327      if [ -f $initrdfile ]; then   fi
  [ -n "$verbose" ] && echo "found $initrdfile and using it with grubby"  
  INITRD="--initrd $initrdfile"  
     fi  
   
     # FIXME: is this a good heuristic to find out if we're on iSeries?  
     if [ -d /proc/iSeries ]; then  
  [ -n "$verbose" ] && echo "On an iSeries, just making img file"  
  if [ -z $initrdfile  ]; then  
     [ -n "$verbose" ] && echo "No initrd, just adding system map"  
     /sbin/addSystemMap $bootPrefix/System.map-$version $bootPrefix/$kernelName-$version $bootPrefix/vmlinitrd-$version  
  else  
     /sbin/addSystemMap $bootPrefix/System.map-$version $bootPrefix/$kernelName-$version $bootPrefix/vmlinux.sm-$version  
     /sbin/addRamDisk $initrdfile $bootPrefix/System.map-$version $bootPrefix/vmlinux.sm-$version $bootPrefix/vmlinitrd-$version 2>/dev/null  
     rm $bootPrefix/vmlinux.sm-$version  
  fi  
  return  
     fi  
   
     # get the root filesystem to use; if it's on a label make sure it's  
     # been configured. if not, get the root device from mount  
     rootdevice=$(awk '{ if ($1 !~ /^[ \t]*#/ && $2 == "/") { print $1; }}' /etc/fstab)  
     short=$(echo $rootdevice | cut -d= -f1)  
     if [ "$short" == "LABEL" ]; then  
  label=$(echo $rootdevice | cut -d= -f2 |head -n 1)  
  device=$(echo "showlabels" | /sbin/nash  --force --quiet |  
  awk '$2 == "'$label'" {print $1}')  
  if [ -z "$device" ]; then  
     rootdevice=$(mount | awk '$3 == "/" { print $1 }')  
  fi  
     fi  
   
     if [ -n "$mbkernel" ]; then  
  mb="--add-multiboot=$mbkernel"  
  if [ -n "$mbargs" ]; then  
     mb="$mb --mbargs=$mbargs"  
  fi  
  [ -n "$verbose" ] && echo "multiboot specified, not updating lilo.conf"  
  cfgLilo=""  
     fi  
   
     if [ -n "$cfgGrub" ]; then  
  [ -n "$verbose" ] && echo "adding $version to $grubConfig"  
   
  if [ -n "$banner" ]; then  
             title="$banner ($version)"  
  elif [ -f /etc/mageversion ]; then  
     title="Magellan Linux $(< /etc/mageversion) ($version)"  
  else  
     title="Magellan Linux ($version)"  
  fi  
  /sbin/grubby --add-kernel=$bootPrefix/$kernelName-$version $INITRD    \  
      --copy-default $makedefault $mb --title "$title"    \  
      --args="root=$rootdevice $kernargs"    \  
      --remove-kernel="TITLE=$title"                  
     else  
  [ -n "$verbose" ] && echo "$grubConfig does not exist, not running grubby"  
     fi  
   
     if [ -n "$cfgLilo" ]; then  
  [ -n "$verbose" ] && echo "adding $version to $liloConfig"  
   
  /sbin/grubby --add-kernel=$bootPrefix/$kernelName-$version $INITRD    \  
      --copy-default $makedefault --title $version    \  
      --args="root=$rootdevice $kernargs"    \  
      --remove-kernel="TITLE=$version"    \  
      --$liloFlag  
   
  if [ -n "$runLilo" ]; then  
     [ -n "$verbose" ] && echo "running $lilo"  
     if [ ! -x $lilo ] ; then  
  [ -n "$verbose" ] && echo "$lilo does not exist"  
     else  
  $lilo > /dev/null  
     fi  
  fi  
     else  
  [ -n "$verbose" ] && echo "$liloConfig does not exist, not running grubby"  
     fi  
328    
329     if [[ -n ${cfgGrub} ]]
330     then
331     [[ -n ${verbose} ]] && echo "removing ${version} from ${grubConfig}"
332     ${grubby} --grub -c ${grubConfig} \
333     --remove-kernel=${kernelImage}
334     else
335     [[ -n ${verbose} ]] && echo "${grubConfig} does not exist, not running grubby for grub 0.97"
336     fi
337     if [[ -n ${cfgGrub2} ]]
338     then
339     [[ -n ${verbose} ]] && echo "removing ${version} from ${grub2Config}"
340     ${grubby} --grub2 -c ${grub2Config} \
341     --remove-kernel=${kernelImage}
342     else
343     [[ -n ${verbose} ]] && echo "${grub2Config} does not exist, not running grubby for grub 2"
344     fi
345     if [[ -n ${cfgGrub2Efi} ]]
346     then
347     [[ -n ${verbose} ]] && echo "removing ${version} from ${grub2EfiConfig}"
348     ${grubby} --grub2 -c ${grub2EfiConfig} --efi \
349     --remove-kernel=${kernelImage}
350     else
351     [[ -n ${verbose} ]] && echo "${grub2EfiConfig} does not exist, not running grubby grub 2 with UEFI"
352     fi
353    
354     if [[ -n ${cfgLilo} ]]
355     then
356     [[ -n ${verbose} ]] && echo "removing ${version} from ${liloConfig}"
357     ${grubby} --remove-kernel=${kernelImage} --${liloFlag}
358    
359     if [[ -n ${runLilo} ]]
360     then
361     [[ -n ${verbose} ]] && echo "running ${lilo}"
362     if [ ! -x ${lilo} ]
363     then
364     [[ -n ${verbose} ]] && echo "${lilo} does not exist"
365     else
366     ${lilo} > /dev/null
367     fi
368     fi
369     else
370     [[ -n ${verbose} ]] && echo "${liloConfig} does not exist, not running grubby"
371     fi
372    
373     if [[ -n ${cfguBoot} ]]
374     then
375     [[ -n ${verbose} ]] && echo "removing ${version} from ${ubootDir}..."
376    
377     if [ -f ${ubootDir}/${ubootKList} ]
378     then
379     tmpKList=$(mktemp ${ubootDir}/${ubootKList}.XXXX)
380     curversion=$(tail -n1 ${ubootDir}/${ubootKList})
381     sed "/$version$/d" ${ubootDir}/${ubootKList} > ${tmpKList}
382     newversion=$(tail -n1 ${tmpKList})
383     if [ -f ${ubootDir}/uImage-${newversion} ] && [ -f ${ubootDir}/uInitrd-${newversion} ]
384     then
385     if [[ ${curversion} != ${newversion} ]]
386     then
387     cp -fp ${ubootDir}/uImage-${newversion} ${ubootDir}/${ubootDefaultImage}
388     if [ $? -ne 0 ]
389     then
390     [[ -n ${verbose} ]] && echo "copy uImage-${newversion} error, default kernel not replaced!" && exit
391     fi
392     cp -fp ${ubootDir}/uInitrd-${newversion} ${ubootDir}/${ubootDefaultInitrd}
393     if [ $? -ne 0 ]
394     then
395     [[ -n ${verbose} ]] && echo "copy uInitrd-${newversion} error, default Initrd not replaced!" && exit
396     fi
397     fi
398    
399     [[ -n ${verbose} ]] && echo "removing uImage-${version}"
400     if [ -f ${ubootDir}/uImage-${version} ]
401     then
402     rm -f ${ubootDir}/uImage-${version}
403     else
404     [[ -n ${verbose} ]] && echo "uImage-${version} did not exist!"
405     fi
406    
407     [[ -n ${verbose} ]] && echo "removing uInitrd-${version}"
408     if [ -f ${ubootDir}/uInitrd-${version} ]
409     then
410     rm -f ${ubootDir}/uInitrd-${version}
411     else
412     [[ -n ${verbose} ]] && echo "uInitrd-${version} did not exist!"
413     fi
414    
415     mv ${tmpKList} ${ubootDir}/${ubootKList}
416     [ -x /sbin/a-b-c ] && /sbin/a-b-c
417     else
418     [[ -n ${verbose} ]] && echo "uImage ${newversion} does not exist!"
419     [ -f ${tmpKList} ] && rm -f ${tmpKList}
420     fi
421     else
422     [[ -n ${verbose} ]] && echo "No previous kernel version.  U-Boot images not removed!"
423     fi
424     else
425     [[ -n ${verbose} ]] && echo "${ubootScript} does not exist, not modifying ${ubootDir}"
426     fi
427    
428     if [[ -n ${cfgExtlinux} ]]
429     then
430     [[ -n ${verbose} ]] && echo "removing ${version} from ${extlinuxConfig}"
431     ${grubby} --extlinux -c ${extlinuxConfig} \
432     --remove-kernel=${kernelImage}
433     else
434     [[ -n ${verbose} ]] && echo "${extlinuxConfig} does not exist, not running grubby for extlinux"
435     fi
436  }  }
437    
438  remove() {  update()
439      # FIXME: is this a good heuristic to find out if we're on iSeries?  {
440      if [ -d /proc/iSeries ]; then   if [ ! -f ${kernelImage} ]
441   [ -n "$verbose" ] && echo "On an iSeries, remove img file"   then
442   rm -f $bootPrefix/$kernelName-$version.img 2>/dev/null   [[ -n ${verbose} ]] && echo "kernel for ${version} does not exist, not running grubby"
443   return   return
444      fi   fi
445    
446      if [ -n "$cfgGrub" ]; then   INITRD=""
447   [ -n "$verbose" ] && echo "removing $version from $grubConfig"   if [ -f ${initrdfile} ]
448   /sbin/grubby --remove-kernel=$bootPrefix/$kernelName-$version   then
449      else   [[ -n ${verbose} ]] && echo "found ${initrdfile} and using it with grubby"
450   [ -n "$verbose" ] && echo "$grubConfig does not exist, not running grubby"   INITRD="--initrd ${initrdfile}"
451      fi  
452     if [[ -n ${addplymouthinitrd} ]]
453      if [ -n "$cfgLilo" ]; then   then
454   [ -n "$verbose" ] && echo "removing $version from $liloConfig"   INITRD="${INITRD} --extra-initrd ${bootPrefix}/initrd-plymouth.img"
455   /sbin/grubby --remove-kernel=$bootPrefix/$kernelName-$version    \   fi
456       --$liloFlag   fi
457    
458   if [ -n "$runLilo" ]; then   if [[ -n ${cfgGrub} ]]
459      [ -n "$verbose" ] && echo "running $lilo"   then
460      if [ ! -x $lilo ] ; then   [[ -n ${verbose} ]] && echo "updating ${version} from ${grubConfig}"
461   [ -n "$verbose" ] && echo "$lilo does not exist"   ${grubby} --grub -c ${grubConfig} \
462      else   --update-kernel=${kernelImage} \
463   $lilo > /dev/null   ${INITRD} \
464      fi   ${kernargs:+--args="${kernargs}"} \
465   fi   ${removeargs:+--remove-args="${removeargs}"} \
466      else   ${mbkernel:+--add-multiboot="${mbkernel}"}
467   [ -n "$verbose" ] && echo "$liloConfig does not exist, not running grubby"   else
468      fi   [[ -n ${verbose} ]] && echo "${grubConfig} does not exist, not running grubby"
469     fi
470    
471     if [[ -n ${cfgGrub2} ]]
472     then
473     [[ -n ${verbose} ]] && echo "updating ${version} from ${grub2Config}"
474     ${grubby} --grub2 -c ${grub2Config} \
475     --update-kernel=${kernelImage} \
476     ${INITRD} \
477     ${kernargs:+--args="${kernargs}"} \
478     ${removeargs:+--remove-args="${removeargs}"}
479     else
480     [[ -n ${verbose} ]] && echo "${grub2Config} does not exist, not running grubby"
481     fi
482    
483     if [[ -n ${cfgGrub2Efi} ]]
484     then
485     [[ -n ${verbose} ]] && echo "updating ${version} from ${grub2EfiConfig}"
486     ${grubby} --grub2 -c ${grub2EfiConfig} --efi \
487     --update-kernel=${kernelImage} \
488     ${INITRD} \
489     ${kernargs:+--args="${kernargs}"} \
490     ${removeargs:+--remove-args="${removeargs}"}
491     else
492     [[ -n ${verbose} ]] && echo "${grub2EfiConfig} does not exist, not running grubby"
493     fi
494    
495     if [[ -n ${cfgLilo} ]]
496     then
497     [[ -n ${verbose} ]] && echo "updating ${version} from ${liloConfig}"
498     ${grubby} --update-kernel=${kernelImage} \
499     ${INITRD} \
500     ${kernargs:+--args="${kernargs}"} \
501     ${removeargs:+--remove-args="${removeargs}"} \
502     --${liloFlag}
503    
504     if [[ -n ${runLilo} ]]
505     then
506     [[ -n ${verbose} ]] && echo "running ${lilo}"
507     if [ ! -x ${lilo} ]
508     then
509     [[ -n ${verbose} ]] && echo "${lilo} does not exist"
510     else
511     ${lilo} > /dev/null
512     fi
513     fi
514     else
515     [[ -n ${verbose} ]] && echo "${liloConfig} does not exist, not running grubby"
516     fi
517    
518     if [[ -n ${cfguBoot} ]]
519     then
520     [[ -n ${verbose} ]] && echo "adding $version to ${ubootDir}..."
521    
522     [[ -n ${verbose} ]] && echo "creating uImage-${version}"
523     mkimage -A arm -O linux -T kernel -C none -a ${ubootAddress} \
524     -e ${ubootAddress} -n ${version} \
525     -d ${kernelImage} ${ubootDir}/uImage-${version}
526    
527     [[ -n ${verbose} ]] && echo "creating uInitrd-${version}"
528     mkimage -A arm -O linux -T ramdisk -C none -a 0 -e 0 \
529     -n initramfs -d ${initrdfile} ${ubootDir}/uInitrd-${version}
530    
531     if [ -f ${ubootDir}/uImage-${version} ] && [ -f ${ubootDir}/uInitrd-${version} ]
532     then
533     cp -fp ${ubootDir}/uImage-${version} ${ubootDir}/${ubootDefaultImage}
534     if [ $? -ne 0 ]
535     then
536     [[ -n ${verbose} ]] && echo "copy uImage-${version} error, kernel not installed!" && exit
537     fi
538     cp -fp ${ubootDir}/uInitrd-${version} ${ubootDir}/${ubootDefaultInitrd}
539     if [ $? -ne 0 ]
540     then
541     [[ -n ${verbose} ]] && echo "copy uInitrd-${version} error, kernel not installed!" && exit
542     fi
543     echo ${version} >> ${ubootDir}/${ubootKList}
544     [ -x /sbin/a-b-c ] && /sbin/a-b-c
545     else
546     [[ -n ${verbose} ]] && echo "cannot make ${version} the default"
547     fi
548     else
549     [[ -n ${verbose} ]] && echo "${ubootScript} does not exist, not setting up ${ubootDir}"
550     fi
551    
552     if [[ -n ${cfgExtlinux} ]]
553     then
554     [[ -n ${verbose} ]] && echo "updating ${version} from ${extlinuxConfig}"
555     ${grubby} --extlinux -c ${extlinuxConfig} \
556     --update-kernel=${kernelImage} \
557     ${INITRD} \
558     ${kernargs:+--args="${kernargs}"} \
559     ${removeargs:+--remove-args="${removeargs}"}
560     else
561     [[ -n ${verbose} ]] && echo "${extlinuxConfig} does not exist, not running grubby"
562     fi
563  }  }
564    
565  mkinitrd() {  makeinitrd()
566      [ -n "$verbose" ] && echo "creating initrd $initrdfile using $version"  {
567      /sbin/mkinitrd --allow-missing -f $initrdfile $version   if [[ -n ${dracut} ]]
568      rc=$?   then
569      if [ $rc != 0 ]; then   tool="dracut ${dracuthostonly} -f ${initrdfile} ${version}"
570   echo "mkinitrd failed" >&2   else
571   exit 1   tool="mkinitrd --allow-missing -f ${initrdfile} ${version}"
572      fi   fi
573     [[ -n ${verbose} ]] && echo "creating initrd ${initrdfile} using ${version}"
574     ${tool}
575     rc=$?
576     if [ ${rc} != 0 ]
577     then
578     echo "mkinitrd failed" >&2
579     exit 1
580     fi
581  }  }
582    
583  rminitrd() {  rminitrd()
584      [ -n "$verbose" ] && echo "removing initrd $initrdfile"  {
585      [ -f $initrdfile ] && rm -f $initrdfile   [[ -n ${verbose} ]] && echo "removing initrd ${initrdfile}"
586     [ -f ${initrdfile} ] && rm -f ${initrdfile}
587  }  }
588    
589  doDepmod() {  doDepmod()
590      [ -n "$verbose" ] && echo "running depmod for $version"  {
591      depmod -ae -F /boot/System.map-$version $version   [[ -n ${verbose} ]] && echo "running depmod for ${version}"
592     depmod -ae -F /boot/System.map-${version} ${version}
593  }  }
594    
595  doRmmoddep() {  doRmmoddep()
596      [ -n "$verbose" ] && echo "removing modules.dep info for $version"  {
597      [ -d /lib/modules/$version ] && rm -f /lib/modules/$version/modules.*       [[ -n ${verbose} ]] && echo "removing modules.dep info for ${version}"
598     if [ -d /lib/modules/${version} ]
599     then
600     rm -f /lib/modules/${version}/modules.*.bin \
601     /lib/modules/${version}/modules.{alias,dep,devname,symbols,softdep}
602     fi
603  }  }
604    
605    
606  while [ $# -gt 0 ]; do  while [ $# -gt 0 ]
607      case $1 in  do
608   --mkinitrd)   case $1 in
609      initrd="make"   --mkinitrd)
610      ;;   initrd="make"
611     ;;
612   --rminitrd)  
613      initrd="remove"   --rminitrd)
614      ;;   initrd="remove"
615     ;;
616   --initrdfile*)  
617      if echo $1 | grep '=' >/dev/null ; then   --dracut)
618       initrdfile=`echo $1 | sed 's/^--initrdfile=//'`   dracut=--dracut
619      else   ;;
620   initrdfile=$2  
621   shift   --host-only)
622      fi       dracuthostonly=-H
623      ;;   ;;
624    
625   --kernel-args*)   --initrdfile*)
626      if echo $1 | grep '=' >/dev/null ; then   if [[ $1 == --initrdfile\=* ]]
627       kernargs=`echo $1 | sed 's/^--kernel-args=//'`   then
628      else   initrdfile=${1#--initrdfile=}
629   kernargs=$2   else
630   shift   initrdfile=$2
631      fi       shift
632      ;;   fi
633     ;;
634   --banner*)  
635      if echo $1 | grep '=' >/dev/null ; then   --kernel-args*)
636       banner=`echo $1 | sed 's/^--banner=//'`   if [[ $1 == --kernel-args\=* ]]
637      else   then
638   banner=$2   kernargs=${1#--kernel-args=}
639   shift   else
640      fi       kernargs=$2
641      ;;   shift
642     fi
643   --multiboot*)   ;;
644      if echo $1 |grep '=' >/dev/null; then  
645   mbkernel=`echo $1 | sed 's/^--multiboot=//'`   --remove-args*)
646      else   if [[ $1 == --remove-args\=* ]]
647   # can't really support having an optional second arg here   then
648   # sorry!   removeargs=${1#--remove-args=}
649   mbkernel="/boot/xen.gz"   else
650      fi   removeargs=$2
651      ;;   shift
652     fi
653   --mbargs*)   ;;
654      if echo $1 |grep '=' >/dev/null; then  
655   mbargs=`echo $1 | sed 's/^--mbargs=//'`   --banner*)
656      else   if [[ $1 == --banner\=* ]]
657   mbargs=$2   then
658   shift   banner=${1#--banner=}
659      fi   else
660      ;;   banner=$2
661     shift
662   --depmod)   fi
663      moddep="make"   ;;
664      ;;  
665     --multiboot*)
666   --rmmoddep)   if [[ $1 == --multiboot\=* ]]
667      moddep="remove"   then
668      ;;   mbkernel=${1#--multiboot=}
669     else
670   --make-default)   # can't really support having an optional second arg here
671      makedefault="--make-default"   # sorry!
672      ;;   mbkernel="/boot/xen.gz"
673     fi
674   --package)   ;;
675      if echo $1 | grep '=' >/dev/null ; then  
676       package=`echo $1 | sed 's/^--package=//'`   --mbargs*)
677      else   if [[ $1 == --mbargs\=* ]]
678   package=$2   then
679   shift   mbargs=${1#--mbargs=}
680      fi       else
681      ;;   mbargs="$2"
682     shift
683   -v)   fi
684      verbose=-v   ;;
685      ;;  
686     --depmod)
687   *)   moddep="make"
688      if [ -z "$mode" ]; then   ;;
689   mode=$1  
690      elif [ -z "$version" ]; then   --rmmoddep)
691   version=$1   moddep="remove"
692      else   ;;
693   usage  
694      fi   --make-default)
695      ;;   makedefault="--make-default"
696      esac   ;;
697    
698     --package*)
699     if [[ $1 == --package\=* ]]
700     then
701     package=${1#--package=}
702     else
703     package=$2
704     shift
705     fi
706     ;;
707    
708     --add-dracut-args)
709     adddracutargs=--add-dracut-args
710     ;;
711    
712     --add-plymouth-initrd)
713     addplymouthinitrd=--add-plymouth-initrd
714     ;;
715    
716     --kernel-image*)
717     if [[ $1 == --kernel-image\=* ]]
718     then
719     kernelImage=${1#--kernel-image=}
720     else
721     kernelImage="$2"
722     shift
723     fi
724     if ! [[ -f ${kernelImage} ]]
725     then
726     echo "Can't find kernel image '${kernelImage}'" >&2
727     usage
728     exit 1
729     fi
730     ;;
731    
732     -v)
733     verbose=-v
734     ;;
735    
736     *)
737     if [[ -z ${mode} ]]
738     then
739     mode=$1
740     elif [[ -z ${version} ]]
741     then
742     version=$1
743     else
744     usage
745     fi
746     ;;
747     esac
748    
749      shift   shift
750  done  done
751    
752  # make sure the mode is valid  # make sure the mode is valid
753  if [ "$mode" != "--install" -a "$mode" != "--remove" ] ; then  if [[ ${mode} != --install ]] && [[ ${mode} != --remove ]] && [[ ${mode} != --update ]]
754      usage  then
755     usage
756  fi  fi
757    
758  if [ -z "$version" ]; then  if [[ -z ${version} ]]
759      usage  then
760     usage
761  fi  fi
762    
763  if [ "$mode" != "--install" -a "$makedefault" ]; then  if [ "${mode}" != "--install" -a "${makedefault}" ]
764      usage  then
765     usage
766  fi  fi
767    
768  # make sure that /dev/loop exist  kernelmajor=$(echo ${kernel} | cut -d . -f 1,2)
 [[ ! -e /dev/loop ]] && modprobe loop  
   
 kernelmajor=`echo $kernel | cut -d . -f 1,2`  
769    
770  # kernel image for 2.4 is vmlinux  # kernel image for 2.4 is kernel
771  if [ $ARCH = 'ppc64' -o $ARCH = 'ppc' ]; then  if [[ ${ARCH} = ppc64 ]] || [[ ${ARCH} = ppc ]]
772    if [ "$kernelmajor" == "2.4" ]; then  then
773        kernelName=vmlinux   if [[ ${kernelmajor} = 2.4 ]]
774    fi   then
775     kernelName=kernel
776     fi
777  fi  fi
778    
779    [[ ${kernelImage} ]] || kernelImage="${bootPrefix}/${kernelName}-${version}"
780    
781  # set the initrd file based on arch; ia64 is the only currently known oddball  # set the initrd file based on arch; ia64 is the only currently known oddball
782  if [ -z "$initrdfile" ]; then  if [[ -z ${initrdfile} ]]
783      if [ `uname -m` = "ia64" ]; then  then
784   initrdfile="/boot/efi/EFI/redhat/initrd-$version.img"   INITRD_NAME_PREFIX="initrd"
785      else   if [[ -n ${dracut} ]]
786   initrdfile="/boot/initrd-$version.img"   then
787      fi   INITRD_NAME_PREFIX="initramfs"
788     fi
789    
790     if [[ $(uname -m) = ia64 ]]
791     then
792     initrdfile="/boot/efi/EFI/redhat/${INITRD_NAME_PREFIX}-${version}.img"
793     else
794     initrdfile="/boot/${INITRD_NAME_PREFIX}-${version}.img"
795     fi
796  fi  fi
797  [ -n "$verbose" ] && echo "initrdfile is $initrdfile"  [[ -n ${verbose} ]] && echo "initrdfile is ${initrdfile}"
798    
799  # set this as the default if we have the package and it matches  # add dracut i18n, keyboard and plymouth kernel args if requested
800  if [ "$mode" == "--install" -a "$UPDATEDEFAULT" == "yes" -a -n "$package" -a -n "$DEFAULTKERNEL" -a "$package" == "$DEFAULTKERNEL" ]; then  if [[ -n ${dracut} ]] || [[ -n ${adddracutargs} ]]
801      makedefault="--make-default"  then
802      [ -n "$verbose" ] && echo "making it the default based on config"   if [ -r /etc/vconsole.conf ]
803  fi   then
804     . /etc/vconsole.conf
805    
806     for i in SYSFONT SYSFONTACM UNIMAP KEYTABLE
807     do
808     val=$(eval echo \$$i)
809     [[ -n ${val} ]] && kernargs="${kernargs} ${i}=${val}"
810     done
811     else
812     if [ -r /etc/conf.d/consolefont ]
813     then
814     . /etc/conf.d/consolefont
815    
816     if [[ -n ${CONSOLEFONT} ]]
817     then
818     kernargs="${kernargs} SYSFONT=${CONSOLEFONT}"
819     fi
820     fi
821    
822     if  [ -r /etc/conf.d/keymap ]
823     then
824     . /etc/conf.d/keymap
825    
826     if [[ -n ${KEYMAP} ]]
827     then
828     kernargs="${kernargs} KEYTABLE=${KEYMAP}"
829     fi
830     fi
831     fi
832    
833  if [ "$moddep" == "make" ]; then   if [ -r /etc/locale.conf ]
834      doDepmod   then
835  elif [ "$moddep" == "remove" ]; then   . /etc/locale.conf
836      doRmmoddep  
837     if [[ -n ${LANG} ]]
838     then
839     kernargs="${kernargs} LANG=${LANG}"
840     fi
841     fi
842  fi  fi
843    
844  if [ "$initrd" == "make" ]; then  # set this as the default if we have the package and it matches
845      mkinitrd  if [[ ${mode} = --install ]] && [[ ${UPDATEDEFAULT} = yes ]] && [[ -n ${package} ]] &&
846  elif [ "$initrd" == "remove" ]; then   [[ -n ${DEFAULTKERNEL} ]] && [[ ${package} = ${DEFAULTKERNEL} ]]
847      rminitrd  then
848     makedefault="--make-default"
849     [[ -n ${verbose} ]] && echo "making it the default based on config"
850    fi
851    
852    if [[ ${moddep} = make ]]
853    then
854     doDepmod
855    elif [[ ${moddep} = remove ]]
856    then
857     doRmmoddep
858    fi
859    
860    if [[ ${initrd} = make ]]
861    then
862     makeinitrd
863    elif [[ ${initrd} = remove ]]
864    then
865     rminitrd
866    fi
867    
868    if [ ! -x ${grubby} ]
869    then
870     [[ -n ${verbose} ]] && echo "${grubby} does not exist"
871     exit 0
872    fi
873    
874    [[ -n ${grubConfig} ]] && [ -f ${grubConfig} ] && cfgGrub=1
875    [[ -n ${grub2Config} ]] && [ -f ${grub2Config} ] && cfgGrub2=1
876    [[ -n ${grub2EfiConfig} ]] && [ -f ${grub2EfiConfig} ] && cfgGrub2Efi=1
877    [[ -n ${liloConfig} ]] && [ -f ${liloConfig} ] && cfgLilo=1
878    [[ -n ${extlinuxConfig} ]] && [ -f ${extlinuxConfig} ] && cfgExtlinux=1
879    
880    # if we have a U-Boot directory, but no boot script, check if the directory
881    # is mounted.  If not, mount it, and then check if a boot script exists.
882    if [[ -n ${ubootDir} ]]
883    then
884     if [ -f ${ubootScript} ]
885     then
886     cfguBoot=1
887     else
888     mountEntry=$(mount | grep ${ubootDir})
889     if [[ -z ${mountEntry} ]]
890     then
891     mount ${ubootDevice} ${ubootDir}
892     mounted=1
893     fi
894     [ -f ${ubootScript} ] && cfguBoot=1
895     fi
896  fi  fi
897    
898  if [ ! -x $grubby ] ; then  # if we're using U-Boot, check if the default load address should change
899      [ -n "$verbose" ] && echo "$grubby does not exist"  if [[ -n ${cfguBoot} ]] && [[ -z ${UBOOT_IMGADDR} ]]
900      exit 0  then
901     [[ ${version}  =~ .([^.]*)$ ]]
902     platform=${BASH_REMATCH[1]}
903     # A few platforms use an alternate kernel load address
904     if [[ ${platform} = omap ]]
905     then
906     ubootAddress=0x80008000
907     elif [[ ${platform} = imx ]]
908     then
909     ubootAddress=0x90008000
910     fi
911  fi  fi
912    
   
 [ -n "$grubConfig" ] && [ -f "$grubConfig" ] && cfgGrub=1;  
 [ -n "$liloConfig" ] && [ -f "$liloConfig" ] && cfgLilo=1;  
   
913  # if we have a lilo config on an x86 box, see if the default boot loader  # if we have a lilo config on an x86 box, see if the default boot loader
914  # is lilo to determine if it should be run  # is lilo to determine if it should be run
915  if [ -n "$cfgLilo" -a -n "$isx86" ]; then  if [[ -n ${cfgLilo} ]] && [[ -n ${isx86} ]]
916      runLilo=$($grubby --bootloader-probe | grep lilo)  then
917     runLilo=$(${grubby} --bootloader-probe | grep lilo)
918    fi
919    
920    if [[ ${mode} = --install ]]
921    then
922     install
923    elif [[ ${mode} = --remove ]]
924    then
925     remove
926    elif [[ ${mode} = --update ]]
927    then
928     update
929  fi  fi
930    
931  if [ "$mode" == "--install" ]; then  # if we mounted the U-Boot directory, unmount it.
932      install  [[ -n ${mounted} ]] && umount ${ubootDir}
 elif [ "$mode" == "--remove" ]; then  
     remove  
 fi  
933    
934  exit 0  exit 0

Legend:
Removed from v.532  
changed lines
  Added in v.2684